// Copyright 1992 by Jon Dart.  All Rights Reserved.

#ifndef _BOARD_HASH_H
#define _BOARD_HASH_H

#include "board.h"
#include "move.h"

extern const hash_t hash_codes[64][16];
extern const hash_t ep_codes[64];
extern const hash_t b_castle_status[6];
extern const hash_t w_castle_status[6];

class Board_Hash
{
	public:
		
	static void free();
	
	static hash_t HashCode(const Board &ABoard);
	
        static hash_t pawn_hash(const Board &b);

        static hash_t Xor( hash_t h, const Square sq, const Piece piece )
        {
           ASSERT(OnBoard(sq));
           return h ^ hash_codes[sq][(int)piece];
        }

        static hash_t king_pawn_hash(const Board &b)
        {
           return Xor(Xor(b.pawn_hash(), b.KingPos(White), whiteKing), b.KingPos(Black), blackKing);
        }
};

#endif

