// Copyright 1992-9 by Jon Dart.  All Rights Reserved.

#ifndef _BOOK_H
#define _BOOK_H

#include "bookread.h"
#include "bookdefs.h"
#include "posnbook.h"
#include "log.h"
#include <fstream.h>

class Book
{
    // interface to the opening book.

    public:
		
    Book();
	
    ~Book();
		
    Move book_move( const Board &b, enum styles style,
      Book_Info &inf);
    // Returns a "book move" if there is one, NullMove otherwise.
    // NOTE: the promotion field of book_move may be wrong;
    // we don't set it.
		
    unsigned book_moves( const Board &b, Move *moves, 
    const unsigned limit);
    // Fills array "moves" with a list of all the book moves for
    // the given position.  Moves are sorted in decreasing order
    // of "goodness".  Moves that are not recommended at all are
    // are not included.  "limit" is the maximum number of moves
    // that can be stored in "moves".  The return value is the
    // number actually stored.		
    
    void learn(const Board &, int rep_count);
    // Activate the book learning feature. Call after a move
    // has been added to the log. Board is the position before the move.
		
    private:
		
    BOOL find_move( const Move &target, unsigned &node);
    void update(const Book_Info &info, float learn_factor);
	
    Book_Reader *reader, *style_reader;
    
};

#endif

