// Copyright 1999 by Jon Dart. All Rights Reserved.
#ifndef _BOOKUTIL_H_
#define _BOOKUTIL_H_

#ifdef _WIN32
#include <windows.h>
typedef HANDLE MEM_HANDLE;
typedef HANDLE FILE_HANDLE;
#endif

// Platform-independent interface for file and shared memory access
// (Currently supports Windows only; may support UNIX later)

class BookUtil
{
   public:
   
   static FILE_HANDLE openFile(const char *name, bool readOnly);
   
   static FILE_HANDLE createFile(const char *name, int initial_size);

   static MEM_HANDLE createMap(FILE_HANDLE, bool readOnly);
   
   static void *map(MEM_HANDLE,long offset, long size, bool readOnly);
   
   static void unmap(void *);
   
   static void closeMap(MEM_HANDLE);

   static void closeFile(FILE_HANDLE);
   
};

#endif
