// Copyright 1999 by Jon Dart.  All Rights Reserved.

#ifndef _POSITION_BOOK_H_
#define _POSITION_BOOK_H_

#include "bookdefs.h"
#include "bookinfo.h"
#include "bookutil.h"
#include "board.h"
#include "move.h"
#include "pinfo.h"

class PositionBook
{
        // provides a simple book for position learning

        public:

        PositionBook();
        // opens book
                
        ~PositionBook();
        // closes book file
                
        const BOOL is_open() const
        {
           return open;
        }
        
        void add(const Position_Info &info);
        
        int size() const;
        
        Position_Info * lookup(const Board &b,int rep_count);
                
       protected:
               
       LPVOID pBook;
       byte *pPage;
       MEM_HANDLE hFileMapping;
       FILE_HANDLE book_file;
       BOOL open;
       Book_Header hdr;
       
};           


#endif
